//+------------------------------------------------------------------+
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  DeepSkyBlue
#property indicator_color2  Red

//
//
//
//
//

extern int    Kijun           = 26;
extern int    MaPeriod        = 200;
extern int    MaMethod        = MODE_LWMA;
extern int    MaPrice         = PRICE_CLOSE;

extern string note            = "turn on Alert = true; turn off = false";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern bool   alertsNotify    = false;
extern string soundFile       = "alert2.wav";

//
//
//
//
//

double kj[];
double ma[];
double trend[];

//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init()
{
     IndicatorBuffers(3);
     SetIndexBuffer(0,kj); 
     SetIndexBuffer(1,ma);
     SetIndexBuffer(2,trend); 
     IndicatorShortName("Kijun-Sen Ma cross"); 
return(0);
}

int deinit() {  return(0);}

//
//
//
//                           
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,k,limit;
   
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

     for (i=limit; i>=0; i--)
     {
        ma[i] = iMA(NULL,0,MaPeriod,0,MaMethod,MaPrice,i);
        double khi    = High[i];
        double klo    = Low[i];
        double kprice = 0;
        if  (i >= Bars - Kijun) continue;
        for (k = 1; k < Kijun; k++)
        {
           kprice = High[i+k];
           if(khi < kprice)  khi  = kprice;
         
           kprice = Low[i+k];
           if(klo  > kprice) klo  = kprice;
        }
        
        if ((khi+klo) > 0.0) 
             kj[i] = (khi + klo)/2; 
        else kj[i] = 0;
        
        //
        //
        //
        //
        //
        
        trend[i] = trend[i+1];
        if (kj[i]>ma[i]) trend[i] = 1;
        if (kj[i]<ma[i]) trend[i] =-1;
            
     }
     
     //
     //
     //
     //
     //
     
     if (alertsOn)
     {
       if (alertsOnCurrent)
            int whichBar = 0;
       else     whichBar = 1;
       if (trend[whichBar] != trend[whichBar+1])
       if (trend[whichBar] == 1)
             doAlert("uptrend");
       else  doAlert("downtrend");       
     }
return(0);
}
     
//
//
//
//
//
//+------------------------------------------------------------------+

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Kijun-Sen Ma cross ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Kijun-Sen Ma cross "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}

